;SuccuNX/theme.jl

;; This theme (SuccuNX) was derived form theme called Copper
;; The original Copper readme:

;;    "copper put together by Wayne Johnson <bigman1@alltel.net> a port of the WindowBlind
;;     theme CopperDeck by renatocveras@uol.com.br 
;;
;;     Some help with problems encountered from Ryan Pavlik <rpav@mythosource.org>"

(let*

 ;; --- DEFINITION START ---
 (
  ;; --- START IMAGE LIST ---
  (font (get-font "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-2"))
  (font-colors (list "#000000000000" "#f200ac004000"))
     
  (title-images       (list (make-image "title_inact.png")
                            (make-image "title.png")))
  (shd-title-images   (list (make-image "title_shd_inact.png")   
                            (make-image "title_shd.png")))
  (iconify-images     (list (make-image "min_inact.png") 
                            (make-image "min.png") 
		                nil (make-image "min_press.png")))
  (maximize-images    (list (make-image "max_inact.png") 
                            (make-image "max.png")
 			            nil (make-image "max_press.png")))
  (close-images       (list (make-image "close_inact.png")
                            (make-image "close.png")
                        nil (make-image "close_press.png")))
  (menu-images        (list (make-image "menu_button_inact.png")
                            (make-image "menu_button.png")
                        nil (make-image "menu_button_press.png")))
  (border-top         (list (make-image "top_border_inact.png") 
                            (make-image "top_border.png")))
  (shd-border-top     (list (make-image "top_border_shd_inact.png")
                            (make-image "top_border_shd.png")))
  (border-bottom      (list (make-image "bottom_border_inact.png") 
                            (make-image "bottom_border.png")))
  (border-right       (list (make-image "right_border_inact.png")
                            (make-image "right_border.png")))
  (border-left        (list (make-image "left_border_inact.png") 
                            (make-image "left_border.png")))
     
  (corner-tl-2        (list (make-image "top_left_corner_2_inact.png") 
                            (make-image "top_left_corner_2.png")
                        nil (make-image "top_left_corner_2.png")))
  (corner-tr-2        (list (make-image "top_right_corner_2_inact.png") 
                            (make-image "top_right_corner_2.png")
                        nil (make-image "top_right_corner_2.png")))
  (corner-tl          (list (make-image "top_left_corner_inact.png")
                            (make-image "top_left_corner.png")))
  (corner-tl-shd   (list (make-image "top_left_corner_shd_inact.png")
                            (make-image "top_left_corner_shd.png")))
  (corner-tr          (list (make-image "top_right_corner_inact.png")
                            (make-image "top_right_corner.png")))
  (corner-tr-shd   (list (make-image "top_right_corner_shd_inact.png")
                            (make-image "top_right_corner_shd.png")))
  (corner-bl          (list (make-image "lower_left_corner_inact.png") 
                            (make-image "lower_left_corner.png")))
  (corner-br          (list (make-image "lower_right_corner_inact.png") 
                            (make-image "lower_right_corner.png")))
  ;; --- END IMAGE LIST ---
  
  ;; --- START FRAME DEFINITION ---   

  ;; --- NORMAL FRAME ---
  (frame
       ;; --- MENU BUTTON ---
      `(((background   . ,menu-images)
         (top-edge     . -28)
	     (left-edge    . -13)
	     (class        . menu-button)
		)

        ;; --- TITLE BAR ---
	    ((background  . ,title-images)
	     (foreground  . ,font-colors)
	     (font        . ,font)
	     (text        . ,window-name)
	     (x-justify   . left)
	     (y-justify   . center)
	     (top-edge    . -28)
	     (left-edge   . 29)
	     (right-edge  . 80)
	     (class       . title)
		)

        ;; --- ICONIFY BUTTON ---
	    ((background  . ,iconify-images)
	     (top-edge    . -28)
	     (right-edge  . 37) 
	     (class       . iconify-button)
		)

	    ((background  . ,maximize-images)
	     (top-edge    . -28)
	     (right-edge  . 12)
	     (class       . maximize-button)
		)

	    ((background  . ,close-images)
	     (top-edge    . -28)
	     (right-edge  . -13)
	     (class       . close-button)
		)

	    ((background  . ,border-left)
	     (top-edge    . 0)
	     (bottom-edge . 0)
	     (left-edge   . -13) 
	     (class       . left-border)
		)

	    ((background  . ,border-right)
	     (top-edge    . 0)
	     (bottom-edge . 0)
	     (right-edge  . -13)
	     (class       . right-border)
		)

	    ((background  . ,border-bottom)
	     (bottom-edge . -8)
	     (right-edge  . 1)  
	     (left-edge   . 1)   
	     (class       . bottom-border)
		)

	    ((background  . ,corner-tl)
	     (top-edge    . -28)
	     (left-edge   . -13)
	     (class       . top-left-corner)
		)

	    ((background  . ,corner-tr)
	     (top-edge    . -28)
	     (right-edge  . -13)
	     (class       . top-right-corner)
		)

	    ((background  . ,corner-bl)
	     (bottom-edge . -9)
	     (left-edge   . -13)  
	     (class       . bottom-left-corner)
		)

	    ((background  . ,corner-br)
	     (bottom-edge . -9)
	     (right-edge  . -13) 
	     (class       . bottom-right-corner)
		)
       )
  ) ;; --- END NORMAL FRAME ---

  ;; --- START SHAPED FRAME ---
  (shaped-frame
      `(((background . ,title-images)
	     (foreground . ,font-colors)
	     (font       . ,font)
	     (text       . ,window-name)
	     (x-justify  . left)
	     (y-justify  . center)
	     (top-edge   . -28)
	     (left-edge  . 29)
	     (right-edge . 80)
	     (class      . title)
		)

	    ((background . ,iconify-images)
	     (top-edge   . -28)
	     (right-edge . 37) 
	     (class      . iconify-button)
		)

	    ((background . ,maximize-images)
	     (top-edge   . -28)
	     (right-edge . 12)
	     (class      . maximize-button)
		)

	    ((background . ,menu-images)    
	     (top-edge   . -28)
	     (left-edge  . -13)
	     (class      . menu-button)
		)

	    ((background . ,close-images)
	     (top-edge   . -28)
	     (right-edge . -13)
	     (class      . close-button)
		)

	    ((background . ,corner-tl)
	     (top-edge   . -28)
	     (left-edge  . -13)
	     (class      . top-left-corner)
		)

	    ((background . ,corner-tr)
	     (top-edge   . -28)
	     (right-edge . -13)
	     (class      . top-right-corner)
		)
       )
  ) ;; --- END SHAPED-FRAME ---

  ;; --- START SHADED FRAME ---
  (shd-frame
      `(((background . ,shd-title-images)
	     (foreground . ,font-colors)
	     (font       . ,font)
	     (text       . ,window-name)
	     (x-justify  . left)
	     (y-justify  . center)
	     (top-edge   . -28)
	     (left-edge  . 29)
	     (right-edge . 80)
	     (class      . title)
		)

	    ((background . ,iconify-images)
	     (top-edge   . -28)
	     (right-edge . 37) 
	     (class      . iconify-button)
		)

	    ((background . ,maximize-images)
	     (top-edge   . -28)
	     (right-edge . 12)
	     (class      . maximize-button)
		)

	    ((background . ,menu-images)    
	     (top-edge   . -28)
	     (left-edge  . -13)
	     (class      . menu-button)
		)

	    ((background . ,close-images)
	     (top-edge   . -28)
	     (right-edge . -13)
	     (class      . close-button)
		)

	    ((background . ,corner-tl-shd)
	     (top-edge   . -28)
	     (left-edge  . -13)
	     (class      . top-left-corner)
		)

	    ((background . ,corner-tr-shd)
	     (top-edge   . -28)
	     (right-edge . -13)
	     (class      . top-right-corner)
		)
       )
  ) ;; --- END SHADED-FRAME ---

  ;; --- START TRANSIENT-FRAME
  (transient-frame
      `(((background . ,border-top)
         (foreground  . "black")
	     (font        . "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-2")
	     (text        . ,window-name)
	     (x-justify   . center)
	     (y-justify   . center)
	     (top-edge   . -20)
	     (left-edge  . 7)
	     (right-edge . 7)
	     (class      . title)
		)

	    ((background  . ,border-left)
	     (top-edge    . 0)
	     (bottom-edge . 0)
	     (left-edge   . -13) 
	     (class       . left-border)
		)

	    ((background  . ,border-right)
	     (top-edge    . 0)
	     (bottom-edge . 0)
	     (right-edge  . -13)
	     (class       . right-border)
		)

	    ((background  . ,border-bottom)
	     (bottom-edge . -8)
	     (right-edge  . 1)  
	     (left-edge   . 1)   
	     (class       . bottom-border)
		)

	    ((background  . ,corner-tl-2)
	     (top-edge    . -20)
	     (left-edge   . -13)
	     (class       . menu-button)
		)

	    ((background  . ,corner-tr-2)
	     (top-edge   . -20)
	     (right-edge . -13)
	     (class      . close-button)
		)

	    ((background  . ,corner-bl)
	     (bottom-edge . -9)
	     (left-edge   . -13)  
	     (class       . bottom-left-corner)
		)

	    ((background  . ,corner-br)
	     (bottom-edge . -9)
	     (right-edge  . -13) 
	     (class       . bottom-right-corner)
		)
	   )
  ) ;; --- END TRANSIENT-FRAME ---
	
  ;; --- START SHAPED-TRANSIENT-FRAME ---
  (shaped-transient-frame
      `(((background   . ,menu-images)
         (top-edge     . -28)
	     (left-edge    . -13)
	     (class        . menu-button)
		)

	    ((background   . ,title-images)
	     (foreground   . ,font-colors)
	     (font         . ,font)
	     (text         . ,window-name)
	     (x-justify    . left)
	     (y-justify    . center)
	     (top-edge     . -28)
	     (left-edge    . 29)
	     (right-edge   . 80)
	     (class        . title)
		)				    

	    ((background   . ,iconify-images)
	     (top-edge     . -28)
	     (right-edge   . 37) 
	     (class        . iconify-button)
		)

        ((background   . ,maximize-images)
         (top-edge     . -28)
	     (right-edge   . 12)
	     (class        . maximize-button)
		)

	    ((background   . ,close-images)
	     (top-edge     . -28)
	     (right-edge   . -13)
	     (class        . close-button)
		)

	    ((background   . ,corner-tl)
	     (top-edge     . -28)
	     (left-edge    . -13)
	     (class        . top-left-corner)
		)

	    ((background   . ,corner-tr)
	     (top-edge     . -28)
	     (right-edge   . -13)
	     (class        . top-right-corner)
		)
       )
  ) ;; --- END SHAPED-TRANSIENT-FRAME ---
  
  ;; --- START SHADED-TRANSIENT-FRAME ---
  (shd-transient-frame
      `(((background . ,shd-border-top)
         (foreground  . "black")
	     (font        . "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-2")
	     (text        . ,window-name)
	     (x-justify   . center)
	     (y-justify   . center)
	     (top-edge   . -20)
	     (left-edge  . 7)
	     (right-edge . 7)
	     (class      . title)
		)

	    ((background   . ,corner-tl-2)
	     (top-edge     . -20)
	     (left-edge    . -13)
	     (class        . menu-button)
		)

	    ((background   . ,corner-tr-2)
	     (top-edge     . -20)
	     (right-edge   . -13)
	     (class        . close-button)
		)
       )
  ) ;; --- END SHADED-TRANSIENT-FRAME ---

 ) ;; --- END DEFINITION ---

 ;; --- FRAME-STYLE DEFINITION ---  
 (add-frame-style 'SuccuNX
   (lambda (w type)   
     (cond
      ((eq type 'shaped) shaped-frame)
      ((eq type 'transient) transient-frame)
      ((eq type 'shaped-transient) shaped-transient-frame)
      ((eq type 'unframed) nil-frame)
      ((eq type 'shaded) shd-frame)
      ((eq type 'shaded-transient) shd-transient-frame)
      ;; Default frame
      ((eq type 'default) frame)
     ) ;; --- END COND ---
   ) ;; --- END LAMBDA ---
 ) ;; --- END ADD-FRAME-STYLE

 (call-after-property-changed 'WM-NAME
    (lambda ()
       (rebuild-frames-with-style 'SuccuNX)))

) ;; --- END-LET ---